/*
 * soundDetector.h
 *
 *  Created on: 2018/04/29
 *      Author: Mv
 */

#ifndef SOUNDDETECTOR_H_
#define SOUNDDETECTOR_H_

/* Includes ------------------------------------------------------------------*/


/* Private define ------------------------------------------------------------*/
typedef enum{
	WAITSTART = 0,
	WAITNEXT = 1,
	MEASURE = 2,
	FINISHED = 3
} ESoundDetectorState;

typedef enum{
	NOT_DETECTED = 0,
	TURN_ON_LIGHT = 1,
	UNKNOWN = 2
} ESound;

typedef struct{
   void (*entry)(void);
   void (*doAction)(void);
   void (*exitAction)(void);
   void (*tickEvent)(void);
   void (*resetEvent)(void);
   ESoundDetectorState (*checkTransition)(void);
}State;

#define SEND_DEBUG_DATA			(0)
#define AVE_NUM					(10)
#define WINDOW_NUM				(4096)
#define THRESHOLD_MV			(400)
#define THRESHOLD_MV2			(2000)
#define THRESHOLD_OFF_COUNT		(WINDOW_NUM)
#define THRESHOLD_DETECT_COUNT	(3100)
#define THRESHOLD_VOLUME_ON		(40)			//[dB]

void run(void);
ESound getDetectedSound(void);
void tickEvent(void);
void reset(void);

#endif /* SOUNDDETECTOR_H_ */
