/*
 * soundCalculator.c
 *
 *  Created on: 2018/04/29
 *      Author: Mv
 */


/* Includes ------------------------------------------------------------------*/
#include "soundCalculator.h"
#include "main.h"
#include "stm32f3xx_hal.h"
#include <stdlib.h>
#include <math.h>

/* External Variables ---------------------------------------------------------*/
extern ADC_HandleTypeDef hadc1;

/* Private Variables ---------------------------------------------------------*/

/* Private Method prototypes -------------------------------------------------*/
/**
 *
 */
int getSoundMilliVoltage(void){

	short milliVoltage = 0;
	short adcValue = 0;

	HAL_ADC_Start(&hadc1);
	HAL_ADC_PollForConversion(&hadc1,1);
	adcValue = HAL_ADC_GetValue(&hadc1);
	HAL_ADC_Stop(&hadc1);

	milliVoltage = ((int)adcValue * (int)VREF_MV / (int)ADC_RESOLUTION) - BASE_VOLTAGE_MV;
	return milliVoltage;

}


/**
 *
 */
void calcLength(void){

}

/**
 *
 */
void calcFFT(short *buffer){

}


/**
 *	Calculate soundVolume[dB] by simple moving average.
 */
unsigned short calcVolumeAve(short* milliVoltageArray,const unsigned short arrayLength){

	int tmpValue1 = 0;
	int tmpValue2 = 0;
	int result = -1;

	//Check Parameter
	if(arrayLength == 0){
		return result;
	}

	//calcAverage[mV]
	for(short i =0; i<arrayLength; i++){
		tmpValue1 += abs((int)milliVoltageArray[i]);
	}
	tmpValue2 = tmpValue1 / arrayLength;

	//[mV][dB]
	if(tmpValue2 == 0){
		result = 0;
	}
	else{
		result = 20*log10((float)tmpValue2);
	}
	return result;

}
